//-----------------------------------------
// SaveLocalRot -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//  The rotation below the class of the selected item is saved.
//parameter 
//  Save Local Rot file : save file name 
@script generic
@name ATSaveLocalRotZ

@define AUTOMATON_VER 2.0

@define LAST_DIR "LastDir_Pose"


s_xHierarchyList;			
s_nHierarchyListSize = 0;

generic 
{
	curScene = Scene();
	xSelected = curScene.firstSelect();	
	if(xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
    var2 = false;

	reqbegin("Save Local Rot"  + AUTOMATON_VER );
    reqsize(267,110);

    //
    var lastDir = globalrecall(LAST_DIR,"");
    var scenesDir = getdir("Scenes");
    var contentDir = getdir("Content");
    var dir = "";
    if( fileexists(lastDir) )
    {
        dir = lastDir;
    }
    else if( fileexists(scenesDir) )
    {
        dir = scenesDir;
	}
    else if( fileexists( contentDir ) )
    {
        dir = contentDir;
    }
    
    
	c1 = ctlfilename("Save Local Rot file",dir, 30 );
    ctlposition(c1,5,5,226,19);
    c2 = ctlcheckbox("Select Item Only",var2);
    ctlposition(c2,12,32,153,19);

	return if !reqpost();

	fileName = getvalue(c1);
    var2 = getvalue(c2);
	
	path = split(fileName);
@if platform == INTEL
	globalstore( LAST_DIR , path[1]+path[2] );
@end		
	reqend();

	if(fileName == nil)
	{
		error("<br>You must select file name" );
		return;		
	}

	items = parse(".",fileName);
	fileName = items[1] + ".lrt" ;

	if( var2 == false )
	{
		for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
		{
			findChildren( xSelected );
			xSelected = curScene.nextSelect();
		}	
	}
	else {
		for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
		{
			s_xHierarchyList[ ++s_nHierarchyListSize ] = xSelected ;
			xSelected = curScene.nextSelect();
		}	
	}

	reqbegin("Save Bone Items " + AUTOMATON_VER );
	ctllistbox("Save Bone Items" , 300 , 300 , "lb_count","lb_name");
	return if !reqpost();

	if((textFile = File(fileName,"w")) == nil)
	{
			error("Could not open file ", fileName );
			return;		
	} 

	for( i = 1 ; i <= s_nHierarchyListSize ; i++ )
	{
		textFile.write( s_xHierarchyList[i].name , ":" );
		v =  s_xHierarchyList[i].getRotation(curScene.currenttime) ;
		textFile.write( " <" , v , ">\n" );
	}
	reqend();
}


findChildren: rootObj
{
	if((itemType = rootObj.genus) == BONE )
	{
		s_xHierarchyList[ ++s_nHierarchyListSize ] = rootObj;
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		findChildren(childObj);
		childObj = rootObj.nextChild();
	}
}

lb_count
{
     return(s_xHierarchyList.size());
}

lb_name: index
{
     return(s_xHierarchyList[index].name);
}


